(* trim : ('a list * 'a list) -> ('a list * 'a list) *)
let rec trim = function
 | (x::xs,y::ys) when x = y -> trim (xs,ys)
 | d -> d

(* extend : ('a list * 'a list) -> ('a list * 'a list) *)
let extend (w1,w2) (d1,d2) = trim (w1@d1,w2@d2)

(* solve : ('a list * 'a list) list -> bool *)
let solve ds =
 let rec solve = function
  | [] -> false
  | ([],[])::_ -> true
  | (x::_,y::_)::ws when x <> y -> solve ws
  | w::ws -> solve (ws@Lst.map (extend w) ds)
 in solve (Lst.map trim ds)

(* samples : *)
let pcp0 = [([0;1],[0]);([0],[1;0])]
let pcp1 = [([0;1],[0]);([1;1],[1;0])] (*no solution*)
let pcp2 = [([0;1],[0]);([0;1],[1;1;0]);([0],[1;0;0]);([1;0;0],[1;0])]
let pcp3 = [([1;0;1],[1]);([0],[0;1]);([1;0],[1;1;0]);([1;1],[1;0])]
let pcp4 = [([0;1],[0]);([0;0],[1;0])] (*no solution*)

