
(* ps : int list *)
let ps = [2;3;5;5;8;12;12;15;15;17]

(* price : int list -> int -> int *)
let price ps i = if i <= Lst.length ps then Lst.nth ps (i-1) else 0

(* cut : int list -> int -> int *)
let rec cut ps n = 
 if n = 0 then 0
 else 
  let f i q = max q (price ps i + cut ps (n-i)) in
  Lst.foldr f (price ps n) (IntLst.range 1 n) 

(* cut_dp : int list -> int -> int *)
let cut_dp ps n =
 let rec cut t ps n = 
  if Lookup.mem t n then t
  else if n = 0 then Lookup.add t n 0
  else 
   let t = Lst.foldr (fun i t -> cut t ps (n-i)) t (IntLst.range 1 n) in
   let f i q = max q (price ps i + Lookup.find t (n-i)) in
   let r = Lst.foldr f (price ps n) (IntLst.range 1 n) in
   Lookup.add t n r
in Lookup.find (cut Lookup.empty ps n) n

(* cut_greedy : int list -> int -> int *)
let rec cut_greedy ps n = 
 if n = 0 then 0 
 else 
  let f i (l,q) = 
   let p = price ps i + price ps (n-i) in
   if p > q then (i,p) else (l,q)
  in
  let (j,_) = Lst.foldr f (n,price ps n) (IntLst.range 1 n) in
  if j = n then price ps n else cut_greedy ps j + cut_greedy ps (n-j)


