(* merge 'a list -> 'a list -> 'a list *)
let rec merge xs ys = match (xs,ys) with
 | ([],ys) -> ys
 | (xs,[]) -> xs
 | (x::xs,y::ys) -> if x < y then x::(merge xs (y::ys))
                             else y::(merge (x::xs) ys)
(* msort 'a list -> 'a list *)
let rec msort = function
 | [] -> []
 | [z] -> [z]
 | zs -> let (xs,ys) = Lst.split_at (Lst.length zs / 2) zs in
         merge (msort xs) (msort ys)
(* insert 'a -> 'a list *)
let rec insert x = function
 | [] -> [x]
 | y::ys -> if x < y then x::y::ys else y::(insert x ys)
(* isort 'a list -> 'a list *)
let rec isort = function
 | [] -> []
 | x::xs -> insert x (isort xs)
(* qsort 'a list -> 'a list *)
let rec qsort = function
 | [] -> []
 | z::zs -> let (xs,ys) = Lst.partition ((>) z) zs in
  qsort xs @ [z] @ qsort ys 
